'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }(); /**
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                      * Created by kakoyi on 2017-03-20.
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                      */

exports.default = function (rpc, local) {
    rpc.Storage = new Storage(local);
};

var _msgpackLite = require('msgpack-lite');

var _msgpackLite2 = _interopRequireDefault(_msgpackLite);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var VERSION = '0.0.1';

function buf2str(buf) {
    return String.fromCharCode.apply(null, buf);
}

function str2buf(str) {
    var buf = new Uint8Array(str.length);
    for (var i = 0, strLen = str.length; i < strLen; i++) {
        buf[i] = str.charCodeAt(i);
    }
    return buf;
}

var Storage = function () {
    function Storage(local, option) {
        _classCallCheck(this, Storage);

        _initialiseProps.call(this);

        this.__local = local;
        this.__isPromise = local.setItem('jsStorage', VERSION) instanceof Promise;
        this.setOption(option);
        this.__init();
    }

    _createClass(Storage, [{
        key: '__init',
        value: function __init() {
            if (this.__isPromise) {
                this.__getRawItem = function (v) {
                    return v;
                };
            } else {
                this.__getRawItem = function (v) {
                    return Promise.resolve(v);
                };
            }
        }
    }]);

    return Storage;
}();

var _initialiseProps = function _initialiseProps() {
    var _this = this;

    this.formatKey = function (key) {
        return _this.__option.encode(key);
    };

    this.formatValue = function (value, expires) {
        var pack = [value, Date.now()];
        if (expires) {
            pack.push(pack[1] + expires * 1000);
        }
        return _this.__option.encode(pack);
    };

    this.setOption = function (option) {
        var last = _this.__option;
        _this.__option = option || {
            defaultValue: null,
            expires: 60 * 2
        };

        _this.__option.encode = _this.__option.encode || function (v) {
            return buf2str(_msgpackLite2.default.encode(v));
        };
        _this.__option.decode = _this.__option.decode || function (v) {
            return _msgpackLite2.default.decode(str2buf(v));
        };

        return last;
    };

    this.getOption = function () {
        return _this.__option;
    };

    this.parseKey = function (key) {
        return _this.__option.decode(key);
    };

    this.parseValue = function (value, defValue) {
        if (value) {
            var pack = _this.__option.decode(value);
            if (Array.isArray(pack) && (pack.length < 3 || Date.now() < pack[2])) {
                defValue = pack[0];
            }
        }
        return defValue;
    };

    this.removeRawItem = function (key) {
        return _this.__local.removeItem(key);
    };

    this.setRawItem = function (key, value) {
        return _this.__local.setItem(key, value);
    };

    this.getRawItem = function (key, parse, sync, save) {
        var value = _this.__getRawItem(_this.__local.getItem(key));

        if (parse) {
            value = value.then(function (v) {
                return parse(v, _this.__option.defaultValue);
            });
        }

        if (sync) {
            save = save || _this.__option.save || _this.setRawItem;
            value = value.then(function (v) {
                return v ? v : sync(key).then(function (res) {
                    save(key, res);return res;
                });
            });
        }
        return value;
    };

    this.getItem = function (key, sync) {
        return _this.load(_this.__option.formatKey(key), sync);
    };

    this.setItem = function (key, value) {
        return _this.save(_this.__option.formatKey(key), value);
    };

    this.remove = function (key) {
        return _this.removeRawItem(_this.__option.formatKey(key));
    };

    this.save = function (key, value, expires) {
        return _this.setRawItem(key, _this.__option.formatValue(value, undefined === expires ? _this.__option.expires : expires));
    };

    this.load = function (key, sync) {
        return _this.getRawItem(key, _this.__option.parseValue, sync || _this.__option.sync, _this.save);
    };

    this.clear = function () {
        return _this.__local.clear();
    };
};